﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.BizTalk.BaseFunctoids;
using System.Reflection;

namespace DKBUG.Functoids
{
    public class StringReplace : BaseFunctoid
    {
        public StringReplace()
        {
            ID = 8000;

            SetupResourceAssembly(GetType().Namespace + ".Resources", Assembly.GetExecutingAssembly());

            SetName("StringReplaceName");
            SetTooltip("StringReplaceTooltip");
            SetDescription("StringReplaceDescription");
            SetBitmap("StringReplaceIcon");

            Category = FunctoidCategory.String;

            SetMinParams(3);
            SetMaxParams(3);

            AddInputConnectionType(ConnectionType.AllExceptRecord);
            AddInputConnectionType(ConnectionType.AllExceptRecord);
            AddInputConnectionType(ConnectionType.AllExceptRecord);

            OutputConnectionType = ConnectionType.AllExceptRecord;

            SetExternalFunctionName(GetType().Assembly.FullName, "DKBUG.Functoids.StringReplace", "Replace");

        }

        public string Replace(string str, string search, string replace)
        {
            return str.Replace(search, replace);
        }
    }
}
